#!/usr/bin/env python
# -*- coding: utf-8 -*-
# SDEX getter for the graph
# Run this every hour or whatever
import urllib2, json
from datetime import datetime


site = urllib2.urlopen("http://coinmarketcap.northpole.ro/api/v5/all.json").read()
data = json.loads(site)

totalcap = sum([float(market["marketCap"]["usd"]) for market in data["markets"][:20]])
totalprice = sum([float(market["price"]["usd"]) for market in data["markets"][:20]])

cappercs = []
pricepercs = []

for market in data["markets"][1:20]:
    marketcap = float(market["marketCap"]["usd"])
    capperc = marketcap / totalcap * 100
    cappercs.append(capperc)
    price = float(market["price"]["usd"])
    priceperc = price / totalprice * 100
    pricepercs.append(priceperc)

averagecapperc = sum(cappercs) / len(cappercs)
averagepriceperc = sum(pricepercs) / len(pricepercs)

sdex = round(abs(averagepriceperc - averagecapperc) * 10, 4)
now = str(datetime.now())[:-7]

with open("/home/andri/smarx/timegraph") as f:
    timegraph = json.loads(f.read())

timegraph.append([now, sdex])

with open("/home/andri/smarx/timegraph", "w") as f:
    f.write(json.dumps(timegraph, indent=4))