#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Smarx
import flask, flask.views, urllib2, json, sys
reload(sys)
sys.setdefaultencoding("utf-8")

app = flask.Flask(__name__)

app.secret_key = "ayy lmao " * 69

colours = ['#82CCB5', '#76CBC8', '#6ACBDE', '#6BBCE9', '#71ABDD', '#7C8BC6', '#877BB9', '#9977B4', '#BD81B7', '#DB87B9', '#DB87B9', '#EA91BD', '#F497A9', '#F69C9B', '#F8A792', '#F9B48A', '#FABC89', '#FFCD7E', '#FEE185', '#FFED81', '#FFF58F', '#EEEB80', '#D5E286', '#B6D884', '#8FCD9E']


def prettynumber(number):
    integer, decimal = "{:.3f}".format(number).split(".")
    if len(integer) > 3:
        pos = -3
        for i in range(1, len(integer)/3 + (len(integer) % 3 != 0)):
            integer = integer[:pos] + "," + integer[pos:]
            pos -= 4        
    return integer + "." + decimal

def prettylist(listt):
    pretty = "[" + ", ".join(["\"" + str(thing) + "\"" for thing in listt]) + "]"
    return pretty

class Main(flask.views.MethodView):
    def get(self):
        if len(flask.session.get('_flashes', [])) == 0:
            flask.flash([0, 20])
        hidebtc, top = flask.session.get('_flashes', [])[0][1]
        hidebtc, top = int(hidebtc), int(top)
        if top == 0 or top < -1:
            top = 20
        try:
            site = urllib2.urlopen("http://coinmarketcap.northpole.ro/api/v5/all.json").read()
            data = json.loads(site)
        except:
            return flask.Response("Looks like the API is down.", mimetype="text/plain")
        
        totalcap = sum([float(market["marketCap"]["usd"]) for market in data["markets"][:top]])
        totalprice = sum([float(market["price"]["usd"]) for market in data["markets"][:top]])
        
        marketcaps = []
        caps = []
        cappercs = []
        prices = []
        pricepercs = []
        
        for market in data["markets"][hidebtc:top]:
            symbol = market["symbol"]
            name = market["name"]
            number = market["position"]
            colour = colours[(int(number)-1) % len(colours)]
            marketcap = float(market["marketCap"]["usd"])
            caps.append(marketcap)
            capperc = marketcap / totalcap * 100
            cappercs.append(capperc)
            price = float(market["price"]["usd"])
            prices.append(price)
            priceperc = price / totalprice * 100
            pricepercs.append(priceperc)
            difference = capperc - priceperc
            marketcaps.append([number, symbol, name, prettynumber(marketcap), capperc, colour,
                               prettynumber(price), priceperc, difference])
        
        length = float(len(marketcaps[1-hidebtc:]))
        averagecap =  prettynumber(sum(caps[1-hidebtc:]) / length)
        averagecapperc = sum(cappercs[1-hidebtc:]) / length
        averageprice = prettynumber(sum(prices[1-hidebtc:]) / length)
        averagepriceperc = sum(pricepercs[1-hidebtc:]) / length
        
        sdex = abs(averagepriceperc - averagecapperc) * 10
        
        with open("timegraph") as f:
            timegraph = json.loads(f.read())[-7:]
        times = [graph[0][11:16] for graph in timegraph]
        sdexes = [graph[1] for graph in timegraph]
        
        flask.flash([prettynumber(totalcap), prettynumber(totalprice), averagecap, averagecapperc,
                     averageprice, averagepriceperc, sdex])
        flask.flash(marketcaps)
        flask.flash([prettylist(times), str(sdexes)])
        
        return flask.render_template("index.html")
    
    def post(self):
        try:
            top = int(flask.request.form["top"])
        except:
            top = 20
        try:
            hidebtc = flask.request.form["hidebtc"]
            hidebtc = 1
        except:
            hidebtc = 0
        flask.flash([hidebtc, top])
        return self.get()

app.add_url_rule('/', view_func = Main.as_view('main'), methods = ['GET', 'POST'])

app.debug = True

if __name__ == '__main__':
    app.run(host='0.0.0.0')